Index: lemon/concepts/heap.h
===================================================================
--- lemon/concepts/heap.h	(revision 2260)
+++ lemon/concepts/heap.h	(revision 2260)
@@ -0,0 +1,223 @@
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+///\ingroup concept
+///\file
+///\brief Classes for representing heaps.
+///
+
+#ifndef LEMON_CONCEPT_HEAP_H
+#define LEMON_CONCEPT_HEAP_H
+
+#include <lemon/bits/invalid.h>
+
+namespace lemon {
+  namespace concepts {
+    /// \addtogroup concept
+    /// @{
+
+
+    /// \brief A concept structure describes the main interface of heaps.
+    ///
+    /// A concept structure describes the main interface of heaps.
+    ///
+    template <typename Item, typename Prio, typename ItemIntMap>
+    class Heap {
+    public:
+  
+
+      /// \brief Type to represent the items states.
+      ///
+      /// Each Item element have a state associated to it. It may be "in heap",
+      /// "pre heap" or "post heap". The later two are indifferent from the
+      /// heap's point of view, but may be useful to the user.
+      ///
+      /// The ItemIntMap _should_ be initialized in such way, that it maps
+      /// PRE_HEAP (-1) to any element to be put in the heap...
+      enum state_enum {
+	IN_HEAP = 0,
+	PRE_HEAP = -1,
+	POST_HEAP = -2
+      };
+      
+      /// \brief The constructor.
+      ///
+      /// The constructor.
+      /// \param _iim should be given to the constructor, since it is used
+      /// internally to handle the cross references. The value of the map
+      /// should be PRE_HEAP (-1) for each element.
+      explicit Heap(ItemIntMap &_iim) {}
+
+      /// \brief The number of items stored in the heap.
+      ///
+      /// Returns the number of items stored in the heap.
+      int size() const { return 0; }
+
+      /// \brief Checks if the heap stores no items.
+      ///
+      /// Returns \c true if and only if the heap stores no items.
+      bool empty() const { return false; }
+
+      /// \brief Makes empty this heap.
+      ///
+      /// Makes this heap empty.
+      void clear();
+
+      /// \brief Insert an item into the heap with the given heap.
+      ///    
+      /// Adds \c i to the heap with priority \c p. 
+      /// \param i The item to insert.
+      /// \param p The priority of the item.
+      void push(const Item &i, const Prio &p) {}
+
+      /// \brief Returns the item with minimum priority.
+      ///
+      /// This method returns the item with minimum priority.  
+      /// \pre The heap must be nonempty.  
+      Item top() const {}
+
+      /// \brief Returns the minimum priority.
+      ///
+      /// It returns the minimum priority.
+      /// \pre The heap must be nonempty.
+      Prio prio() const {}
+
+      /// \brief Deletes the item with minimum priority.
+      ///
+      /// This method deletes the item with minimum priority.
+      /// \pre The heap must be non-empty.  
+      void pop() {}
+
+      /// \brief Deletes \c i from the heap.
+      ///
+      /// This method deletes item \c i from the heap, if \c i was
+      /// already stored in the heap.
+      /// \param i The item to erase. 
+      void erase(const Item &i) {}
+
+      /// \brief Returns the priority of \c i.
+      ///
+      /// This function returns the priority of item \c i.  
+      /// \pre \c i must be in the heap.
+      /// \param i The item.
+      Prio operator[](const Item &i) const {}
+
+      /// \brief \c i gets to the heap with priority \c p independently 
+      /// if \c i was already there.
+      ///
+      /// This method calls \ref push(\c i, \c p) if \c i is not stored
+      /// in the heap and sets the priority of \c i to \c p otherwise.
+      /// It may throw an \e UnderFlowPriorityException. 
+      /// \param i The item.
+      /// \param p The priority.
+      void set(const Item &i, const Prio &p) {}
+      
+      /// \brief Decreases the priority of \c i to \c p.
+      ///
+      /// This method decreases the priority of item \c i to \c p.
+      /// \pre \c i must be stored in the heap with priority at least \c p.
+      /// \param i The item.
+      /// \param p The priority.
+      void decrease(const Item &i, const Prio &p) {}
+
+      /// \brief Increases the priority of \c i to \c p.
+      ///
+      /// This method sets the priority of item \c i to \c p. 
+      /// \pre \c i must be stored in the heap with priority at most \c
+      /// p relative to \c Compare.
+      /// \param i The item.
+      /// \param p The priority.
+      void increase(const Item &i, const Prio &p) {}
+
+      /// \brief Returns if \c item is in, has already been in, or has 
+      /// never been in the heap.
+      ///
+      /// This method returns PRE_HEAP if \c item has never been in the
+      /// heap, IN_HEAP if it is in the heap at the moment, and POST_HEAP
+      /// otherwise. In the latter case it is possible that \c item will
+      /// get back to the heap again.
+      /// \param i The item.
+      state_enum state(const Item &i) const {}
+
+      /// \brief Sets the state of the \c item in the heap.
+      ///
+      /// Sets the state of the \c item in the heap. It can be used to
+      /// manually clear the heap when it is important to achive the
+      /// better time complexity.
+      /// \param i The item.
+      /// \param st The state. It should not be \c IN_HEAP. 
+      void state(const Item& i, state_enum st) {}
+
+
+      template <typename _Heap>
+      struct Constraints {
+      public:
+    
+	void constraints() {
+	  Item item;
+	  Prio prio;
+
+	  item=Item();
+	  prio=Prio();
+
+	  ignore_unused_variable_warning(item);
+	  ignore_unused_variable_warning(prio);
+
+	  typedef typename _Heap::state_enum state_enum;
+	  state_enum state;
+
+	  ignore_unused_variable_warning(state);
+      
+	  _Heap heap1 = _Heap(map);
+
+	  ignore_unused_variable_warning(heap1);
+      
+	  heap.push(item, prio);
+
+	  prio = heap.prio();
+	  item = heap.top();
+
+	  heap.pop();
+
+	  heap.set(item, prio);
+	  heap.decrease(item, prio);
+	  heap.increase(item, prio);
+	  prio = heap[item];
+
+	  heap.erase(item);
+
+	  state = heap.state(item);
+
+	  state = _Heap::PRE_HEAP;
+	  state = _Heap::IN_HEAP;
+	  state = _Heap::POST_HEAP;
+
+	  heap.clear();
+	}
+    
+	_Heap& heap;
+	ItemIntMap& map;
+
+	Constraints() : heap(0), map(0) {}
+      };
+    };
+
+    /// @}
+  } // namespace lemon
+}
+#endif // LEMON_CONCEPT_PATH_H
Index: lemon/concepts/maps.h
===================================================================
--- lemon/concepts/maps.h	(revision 2260)
+++ lemon/concepts/maps.h	(revision 2260)
@@ -0,0 +1,192 @@
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#ifndef LEMON_CONCEPT_MAPS_H
+#define LEMON_CONCEPT_MAPS_H
+
+#include <lemon/bits/utility.h>
+#include <lemon/concept_check.h>
+
+///\ingroup concept
+///\file
+///\brief Map concepts checking classes for testing and documenting.
+
+namespace lemon {
+
+  namespace concepts {
+  
+    /// \addtogroup concept
+    /// @{
+
+    /// Readable map concept
+    template<typename K, typename T>
+    class ReadMap
+    {
+    public:
+      /// Map's key type.
+      typedef K Key;    
+      /// Map's value type. (The type of objects associated with the keys).
+      typedef T Value;
+
+      // \bug Value don't need to be default constructible.
+      /// Returns the value associated with a key.
+      Value operator[](const Key &) const {return Value();}
+
+      template<typename _ReadMap>
+      struct Constraints {
+
+	void constraints() {
+	  Value val = m[key];
+	  val = m[key];
+	  typename _ReadMap::Value own_val = m[own_key]; 
+	  own_val = m[own_key]; 
+
+	  ignore_unused_variable_warning(val);
+	  ignore_unused_variable_warning(own_val);
+	  ignore_unused_variable_warning(key);
+	}
+	Key& key;
+	typename _ReadMap::Key& own_key;
+	_ReadMap& m;
+      };
+      
+    };
+
+
+    /// Writable map concept
+    template<typename K, typename T>
+    class WriteMap
+    {
+    public:
+      /// Map's key type.
+      typedef K Key;    
+      /// Map's value type. (The type of objects associated with the keys).
+      typedef T Value;
+
+      /// Sets the value associated with a key.
+      void set(const Key &,const Value &) {}
+
+      ///Default constructor
+      WriteMap() {}
+
+      template <typename _WriteMap>
+      struct Constraints {
+	void constraints() {
+	  // No constraints for constructor.
+	  m.set(key, val);
+	  m.set(own_key, own_val);
+	  ignore_unused_variable_warning(key);
+	  ignore_unused_variable_warning(val);
+	  ignore_unused_variable_warning(own_key);
+	  ignore_unused_variable_warning(own_val);
+	}
+
+	Value& val;
+	typename _WriteMap::Value own_val;
+	Key& key;
+	typename _WriteMap::Key& own_key;
+	_WriteMap& m;
+
+      };
+    };
+
+    ///Read/Writable map concept
+    template<typename K, typename T>
+    class ReadWriteMap : public ReadMap<K,T>,
+			    public WriteMap<K,T>
+    {
+    public:
+      /// Map's key type.
+      typedef K Key;    
+      /// Map's value type. (The type of objects associated with the keys).
+      typedef T Value;
+
+      /// Returns the value associated with a key.
+      Value operator[](const Key &) const {return Value();}
+      /// Sets the value associated with a key.
+      void set(const Key & ,const Value &) {}
+
+      template<typename _ReadWriteMap>
+      struct Constraints {
+	void constraints() {
+	  checkConcept<ReadMap<K, T>, _ReadWriteMap >();
+	  checkConcept<WriteMap<K, T>, _ReadWriteMap >();
+	}
+      };
+    };
+  
+  
+    ///Dereferable map concept
+    template<typename K, typename T, typename R, typename CR>
+    class ReferenceMap : public ReadWriteMap<K,T>
+    {
+    public:
+      /// Tag for reference maps.
+      typedef True ReferenceMapTag;
+      /// Map's key type.
+      typedef K Key;    
+      /// Map's value type. (The type of objects associated with the keys).
+      typedef T Value;
+      /// Map's reference type.
+      typedef R Reference;
+      /// Map's const reference type.
+      typedef CR ConstReference;
+
+    protected:
+      Value tmp;
+    public:
+
+      ///Returns a reference to the value associated to a key.
+      Reference operator[](const Key &) { return tmp; }
+      ///Returns a const reference to the value associated to a key.
+      ConstReference operator[](const Key &) const
+      { return tmp; }
+      /// Sets the value associated with a key.
+      void set(const Key &k,const Value &t) { operator[](k)=t; }
+
+      // \todo rethink this concept
+      template<typename _ReferenceMap>
+      struct ReferenceMapConcept {
+
+	void constraints() {
+	  checkConcept<ReadWriteMap, _ReferenceMap >();
+	  m[key] = val;
+	  val  = m[key];
+	  m[key] = ref;
+	  ref = m[key];
+	  m[own_key] = own_val;
+	  own_val  = m[own_key];
+	  m[own_key] = own_ref;
+	  own_ref = m[own_key];	  	  
+	}
+
+	typename _ReferenceMap::Key& own_key;
+	typename _ReferenceMap::Value& own_val;
+	typename _ReferenceMap::Reference& own_ref;
+	Key& key;
+	Value& val;
+	Reference& ref;
+	_ReferenceMap& m;
+      };
+    };
+
+    // @}
+
+  } //namespace concepts
+} //namespace lemon
+#endif // LEMON_CONCEPT_MAPS_H
Index: lemon/concepts/matrix_maps.h
===================================================================
--- lemon/concepts/matrix_maps.h	(revision 2260)
+++ lemon/concepts/matrix_maps.h	(revision 2260)
@@ -0,0 +1,207 @@
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#ifndef LEMON_CONCEPT_MATRIX_MAPS_H
+#define LEMON_CONCEPT_MATRIX_MAPS_H
+
+#include <lemon/bits/utility.h>
+#include <lemon/concept_check.h>
+
+///\ingroup concept
+///\file
+///\brief MatrixMap concepts checking classes for testing and documenting.
+
+namespace lemon {
+
+  namespace concepts {
+  
+    /// \addtogroup concept
+    /// @{
+
+    /// Readable matrix map concept
+    template <typename K1, typename K2, typename V>
+    class ReadMatrixMap
+    {
+    public:
+      /// Map's first key type.
+      typedef K1 FirstKey;    
+      /// Map's second key type.
+      typedef K2 SecondKey;    
+      /// \brief Map's value type. 
+      /// (The type of objects associated with the pairs of keys).
+      typedef V Value;
+
+      // \bug Value don't need to be default constructible.
+      /// Returns the value associated with a key.
+      Value operator()(const FirstKey&, const SecondKey&) const {
+	return Value();
+      }
+
+      template <typename _ReadMatrixMap>
+      struct Constraints {
+
+	void constraints() {
+	  Value val = m(first_key, second_key);
+	  val = m(first_key, second_key);
+	  typename _ReadMatrixMap::Value own_val = 
+	    m(own_first_key, own_second_key); 
+	  own_val = m(own_first_key, own_second_key);
+	  ignore_unused_variable_warning(val);
+	  ignore_unused_variable_warning(own_val);
+	}
+
+	FirstKey& first_key;
+	SecondKey& second_key;	
+	typename _ReadMatrixMap::FirstKey& own_first_key;
+	typename _ReadMatrixMap::SecondKey& own_second_key;
+	_ReadMatrixMap& m;
+      };
+      
+    };
+
+
+    /// Writable map concept
+    template <typename K1, typename K2, typename V>
+    class WriteMatrixMap {
+    public:
+      /// Map's first key type.
+      typedef K1 FirstKey;    
+      /// Map's second key type.
+      typedef K2 SecondKey;    
+      /// \brief Map's value type. 
+      /// (The type of objects associated with the pairs of keys).
+      typedef V Value;
+
+      /// Sets the value associated with the pair of keys.
+      void set(const FirstKey&, const SecondKey& ,const Value&) {}
+
+      template <typename _WriteMatrixMap>
+      struct Constraints {
+	void constraints() {
+	  // No constraints for constructor.
+	  m.set(first_key, second_key, val);
+	  m.set(own_first_key, own_second_key, own_val);
+	}
+
+	Value& val;
+	typename _WriteMatrixMap::Value own_val;
+	FirstKey& first_key;
+	SecondKey& second_key;
+	typename _WriteMatrixMap::FirstKey& own_first_key;
+	typename _WriteMatrixMap::SecondKey& own_second_key;
+	_WriteMatrixMap& m;
+
+      };
+    };
+
+    ///Read/Writable map concept
+    template<typename K1, typename K2, typename V>
+    class ReadWriteMatrixMap 
+      : public ReadMatrixMap<K1, K2, V>, public WriteMatrixMap<K1, K2, V> {
+    public:
+      /// Map's first key type.
+      typedef K1 FirstKey;    
+      /// Map's second key type.
+      typedef K2 SecondKey;    
+      /// \brief Map's value type. 
+      /// (The type of objects associated with the pairs of keys).
+      typedef V Value;
+
+      /// Returns the value associated with a pair of keys.
+      Value operator()(const FirstKey&, const SecondKey&) const { 
+	return Value(); 
+      }
+      /// Sets the value associated with the pair of keys.
+      void set(const FirstKey&, const SecondKey& ,const Value&) {}
+
+      template<typename _ReadWriteMatrixMap>
+      struct Constraints {
+	void constraints() {
+	  checkConcept<ReadMatrixMap<K1, K2, V>, _ReadWriteMatrixMap >();
+	  checkConcept<WriteMatrixMap<K1, K2, V>, _ReadWriteMatrixMap >();
+	}
+      };
+    };
+  
+  
+    ///Dereferable matrix map concept
+    template<typename K1, typename K2, typename V, typename R, typename CR>
+    class ReferenceMatrixMap : public ReadWriteMatrixMap<K1, K2, V>
+    {
+    public:
+      /// Tag for reference maps.
+      typedef True ReferenceMapTag;
+      /// Map's first key type.
+      typedef K1 FirstKey;    
+      /// Map's second key type.
+      typedef K1 SecondKey;    
+      /// Map's value type. (The type of objects associated with the keys).
+      typedef V Value;
+      /// Map's reference type.
+      typedef R Reference;
+      /// Map's const reference type.
+      typedef CR ConstReference;
+
+    protected:
+      Value tmp;
+    public:
+
+      ///Returns a reference to the value associated to a pair of keys.
+      Reference operator()(const FirstKey&, const SecondKey&) { 
+	return tmp; 
+      }
+      ///Returns a const reference to the value associated to a pair of keys.
+      ConstReference operator()(const FirstKey&, const SecondKey&) const { 
+	return tmp; 
+      }
+      /// Sets the value associated with the pair of keys.
+      void set(const FirstKey&, const SecondKey& ,const Value&) {}
+
+      // \todo rethink this concept
+      template<typename _ReferenceMatrixMap>
+      struct ReferenceMapConcept {
+
+	void constraints() {
+	  checkConcept<ReadWriteMatrixMap, _ReferenceMatrixMap >();
+	  m(first_key, second_key) = val;
+	  val  = m(first_key, second_key);
+	  m(first_key, second_key) = ref;
+	  ref = m(first_key, second_key);
+	  m(own_first_key, own_second_key) = own_val;
+	  own_val  = m(own_first_key, own_second_key);
+	  m(own_first_key, own_second_key) = own_ref;
+	  own_ref = m(own_first_key, own_second_key); 
+	}
+
+	typename _ReferenceMatrixMap::Key& own_first_key;
+	typename _ReferenceMatrixMap::Key& own_second_key;
+	typename _ReferenceMatrixMap::Value& own_val;
+	typename _ReferenceMatrixMap::Reference& own_ref;
+	FirstKey& first_key;
+	SecondKey& second_key;
+	Value& val;
+	Reference& ref;
+	_ReferenceMatrixMap& m;
+      };
+    };
+
+    // @}
+
+  } //namespace concepts
+} //namespace lemon
+#endif // LEMON_CONCEPT_MATRIX_MAPS_H
Index: lemon/concepts/path.h
===================================================================
--- lemon/concepts/path.h	(revision 2260)
+++ lemon/concepts/path.h	(revision 2260)
@@ -0,0 +1,294 @@
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+///\ingroup concept
+///\file
+///\brief Classes for representing paths in graphs.
+///
+///\todo Iterators have obsolete style
+
+#ifndef LEMON_CONCEPT_PATH_H
+#define LEMON_CONCEPT_PATH_H
+
+#include <lemon/bits/invalid.h>
+#include <lemon/concept_check.h>
+
+namespace lemon {
+  namespace concepts {
+    /// \addtogroup concept
+    /// @{
+
+
+    //! \brief A skeleton structure for representing directed paths in a graph.
+    //!
+    //! A skeleton structure for representing directed paths in a graph.
+    //! \param _Graph The graph type in which the path is.
+    //!
+    //! In a sense, the path can be treated as a graph, for it has \c NodeIt
+    //! and \c EdgeIt with the same usage. These types converts to the \c Node
+    //! and \c Edge of the original graph.
+    template<typename _Graph>
+    class Path {
+    public:
+
+      /// Type of the underlying graph.
+      typedef _Graph Graph;
+      /// Edge type of the underlying graph.
+      typedef typename Graph::Edge Edge;
+      /// Node type of the underlying graph.
+      typedef typename Graph::Node Node;
+
+      class NodeIt;
+      class EdgeIt;
+
+      /// \param _g The graph in which the path is.
+      ///
+      Path(const Graph &_g) {
+	ignore_unused_variable_warning(_g);
+      }
+
+      /// Length of the path ie. the number of edges in the path.
+      int length() const {return 0;}
+
+      /// Returns whether the path is empty.
+      bool empty() const { return true;}
+
+      /// Resets the path to an empty path.
+      void clear() {}
+
+      /// \brief Starting point of the path.
+      ///
+      /// Starting point of the path.
+      /// Returns INVALID if the path is empty.
+      Node target() const {return INVALID;}
+      /// \brief End point of the path.
+      ///
+      /// End point of the path.
+      /// Returns INVALID if the path is empty.
+      Node source() const {return INVALID;}
+
+      /// \brief The target of an edge.
+      ///
+      /// Returns node iterator pointing to the target node of the
+      /// given edge iterator.
+      NodeIt target(const EdgeIt&) const {return INVALID;}
+
+      /// \brief The source of an edge.
+      ///
+      /// Returns node iterator pointing to the source node of the
+      /// given edge iterator.
+      NodeIt source(const EdgeIt&) const {return INVALID;}
+
+      /// \brief Iterator class to iterate on the nodes of the paths
+      ///
+      /// This class is used to iterate on the nodes of the paths
+      ///
+      /// Of course it converts to Graph::Node.
+      class NodeIt {
+      public:
+	/// Default constructor
+	NodeIt() {}
+	/// Invalid constructor
+	NodeIt(Invalid) {}
+	/// Constructor with starting point
+	NodeIt(const Path &) {}
+
+	///Conversion to Graph::Node
+	operator Node() const { return INVALID; }
+	/// Next node
+	NodeIt& operator++() {return *this;}
+
+	/// Comparison operator
+	bool operator==(const NodeIt&) const {return true;}
+	/// Comparison operator
+	bool operator!=(const NodeIt&) const {return true;}
+ 	/// Comparison operator
+ 	bool operator<(const NodeIt&) const {return false;}
+
+      };
+
+      /// \brief Iterator class to iterate on the edges of the paths
+      ///
+      /// This class is used to iterate on the edges of the paths
+      ///
+      /// Of course it converts to Graph::Edge
+      class EdgeIt {
+      public:
+	/// Default constructor
+	EdgeIt() {}
+	/// Invalid constructor
+	EdgeIt(Invalid) {}
+	/// Constructor with starting point
+	EdgeIt(const Path &) {}
+
+	operator Edge() const { return INVALID; }
+
+	/// Next edge
+	EdgeIt& operator++() {return *this;}
+
+	/// Comparison operator
+	bool operator==(const EdgeIt&) const {return true;}
+	/// Comparison operator
+	bool operator!=(const EdgeIt&) const {return true;}
+ 	/// Comparison operator
+ 	bool operator<(const EdgeIt&) const {return false;}
+
+      };
+
+
+      friend class Builder;
+
+      /// \brief Class to build paths
+      ///
+      /// This class is used to fill a path with edges.
+      ///
+      /// You can push new edges to the front and to the back of the path in
+      /// arbitrary order then you should commit these changes to the graph.
+      ///
+      /// While the builder is active (after the first modifying
+      /// operation and until the call of \ref commit()) the
+      /// underlining Path is in a "transitional" state (operations on
+      /// it have undefined result).
+      class Builder {
+      public:
+
+        /// Constructor
+
+        /// Constructor
+	/// \param _path the path you want to fill in.
+	///
+
+	Builder(Path &_path) { ignore_unused_variable_warning(_path); }
+
+	/// Sets the starting node of the path.
+
+	/// Sets the starting node of the path. Edge added to the path
+	/// afterwards have to be incident to this node.
+	/// You \em must start building an empty path with these functions.
+	/// (And you \em must \em not use it later).
+	/// \sa pushFront()
+	/// \sa pushBack()
+	void setStartNode(const Node &) {}
+
+	///Push a new edge to the front of the path
+
+	///Push a new edge to the front of the path.
+	///If the path is empty, you \em must call \ref setStartNode() before
+	///the first use of \ref pushFront().
+	void pushFront(const Edge&) {}
+
+	///Push a new edge to the back of the path
+
+	///Push a new edge to the back of the path.
+	///If the path is empty, you \em must call \ref setStartNode() before
+	///the first use of \ref pushBack().
+	void pushBack(const Edge&) {}
+
+	///Commit the changes to the path.
+
+	///Commit the changes to the path.
+        ///
+	void commit() {}
+
+	///Reserve (front) storage for the builder in advance.
+
+	///If you know a reasonable upper bound on the number of the edges
+	///to add to the front of the path,
+	///using this function you may speed up the building.
+	void reserveFront(size_t) {}
+	///Reserve (back) storage for the builder in advance.
+
+	///If you know a reasonable upper bound on the number of the edges
+	///to add to the back of the path,
+	///using this function you may speed up the building.
+	void reserveBack(size_t) {}
+      };
+
+      template <typename _Path>
+      struct Constraints {
+	void constraints() {
+          typedef typename _Path::Node Node;
+          typedef typename _Path::NodeIt NodeIt;
+          typedef typename Graph::Node GraphNode;
+
+          typedef typename _Path::Edge Edge;
+          typedef typename _Path::EdgeIt EdgeIt;
+          typedef typename Graph::Edge GraphEdge;
+
+          typedef typename _Path::Builder Builder;
+
+          path = _Path(graph);
+
+          bool b = cpath.empty();
+          int l = cpath.length();
+
+          Node gn;
+          Edge ge;
+          gn = cpath.source();
+          gn = cpath.target();
+
+          NodeIt nit;
+          EdgeIt eit(INVALID);
+          nit = path.source(eit);
+          nit = path.target(eit);
+          
+          nit = NodeIt();
+          nit = NodeIt(cpath);
+          nit = INVALID;
+          gn = nit;
+          ++nit;
+          b = nit == nit;
+          b = nit != nit;
+          b = nit < nit;
+
+          eit = EdgeIt();
+          eit = EdgeIt(cpath);
+          eit = INVALID;
+          ge = eit;
+          ++eit;
+          b = eit == eit;
+          b = eit != eit;
+          b = eit < eit;
+
+          size_t st = 0;
+
+          Builder builder(path); 
+          builder.setStartNode(gn);
+          builder.pushFront(ge);
+          builder.pushBack(ge);
+          builder.commit();
+          builder.reserveFront(st);
+          builder.reserveBack(st);
+          
+          ignore_unused_variable_warning(l);
+          ignore_unused_variable_warning(b);
+	}
+
+        const Graph& graph;
+        const _Path& cpath;
+        _Path& path;
+      };
+
+    };
+
+  ///@}
+  }
+
+} // namespace lemon
+
+#endif // LEMON_CONCEPT_PATH_H
